/// <reference types="node" />
import { WorkspaceContext, Indexer, TagInfo } from '@salesforce/lightning-lsp-common';
import EventsEmitter from 'events';
export default class AuraIndexer implements Indexer {
    readonly eventEmitter: EventsEmitter;
    private context;
    private indexingTasks;
    private AURA_TAGS;
    private AURA_EVENTS;
    private AURA_NAMESPACES;
    constructor(context: WorkspaceContext);
    configureAndIndex(): Promise<void>;
    waitForIndexing(): Promise<void>;
    resetIndex(): void;
    getAuraTags(): Map<string, TagInfo>;
    getAuraNamespaces(): string[];
    getAuraByTag(tag: string): TagInfo;
    clearTagsforDirectory(directory: string, sfdxProject: boolean): void;
    indexFile(file: string, sfdxProject: boolean): Promise<TagInfo | undefined>;
    private indexCustomComponents;
    private clearTagsforFile;
    private deleteCustomTag;
    private setAuraNamespaceTag;
    private setCustomEventTag;
    private setCustomTag;
    private loadSystemTags;
    private loadStandardComponents;
    private searchAura;
    private trimQuotes;
    private getTagInfo;
}
//# sourceMappingURL=indexer.d.ts.map