"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lightning_lsp_common_1 = require("@salesforce/lightning-lsp-common");
const path_1 = require("path");
const AURA_STANDARD = 'aura-standard.json';
const AURA_SYSTEM = 'aura-system.json';
const AURA_EXTENSIONS = ['.cmp', '.app', '.design', '.evt', '.intf', '.auradoc', '.tokens'];
const RESOURCES_DIR = 'resources';
function isAuraMarkup(textDocument) {
    const fileExt = lightning_lsp_common_1.utils.getExtension(textDocument);
    return AURA_EXTENSIONS.includes(fileExt);
}
exports.isAuraMarkup = isAuraMarkup;
function getAuraStandardResourcePath() {
    return path_1.join(__dirname, RESOURCES_DIR, AURA_STANDARD);
}
exports.getAuraStandardResourcePath = getAuraStandardResourcePath;
function getAuraSystemResourcePath() {
    return path_1.join(__dirname, RESOURCES_DIR, AURA_SYSTEM);
}
exports.getAuraSystemResourcePath = getAuraSystemResourcePath;
//# sourceMappingURL=aura-utils.js.map